import AuthProvider from '@/providers/AuthProvider';
import ThemeProvider, { useTheme } from '@/providers/ThemeProvider';
import { useFonts } from 'expo-font';
import { Stack } from 'expo-router';
import * as SplashScreen from 'expo-splash-screen';
import { StatusBar } from 'expo-status-bar';
import { useEffect } from 'react';
import { GestureHandlerRootView } from 'react-native-gesture-handler';
import { NotifierWrapper } from 'react-native-notifier';
import 'react-native-reanimated';
import Styles from '@/constants/Styles';

// Prevent the splash screen from auto-hiding before asset loading is complete.
SplashScreen.preventAutoHideAsync();

// Inner component - berada di dalam ThemeProvider, bisa pakai useTheme()
function AppStack() {
  const { colors } = useTheme();

  return (
    <>
      <Stack screenOptions={{ contentStyle: { backgroundColor: colors.header } }}>
        <Stack.Screen name="index" options={{ headerShown: false }} />
        <Stack.Screen name="verification" options={{ headerShown: false }} />
        <Stack.Screen name="(application)" options={{ headerShown: false }} />
      </Stack>
      <StatusBar style="auto" />
    </>
  );
}

export default function RootLayout() {
  const [loaded] = useFonts({
    SpaceMono: require('../assets/fonts/SpaceMono-Regular.ttf'),
  });

  useEffect(() => {
    if (loaded) {
      SplashScreen.hideAsync();
    }
  }, [loaded]);

  if (!loaded) {
    return null;
  }

  return (
    <GestureHandlerRootView style={Styles.flex1}>
      <NotifierWrapper>
        <ThemeProvider>
          <AuthProvider>
            <AppStack />
          </AuthProvider>
        </ThemeProvider>
      </NotifierWrapper>
    </GestureHandlerRootView>
  );
}
